<template>
  <MainTemplate>
    <template #headerInsert>
      <RouterLink to="../" class="text-primary">zurück zur Liste (abbrechen)</RouterLink>
    </template>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Termintyp {{ origin?.type }} - Daten bearbeiten</h1>
      </div>
    </template>
    <template #main>
      <Spinner v-if="loading == 'loading'" class="mx-auto" />
      <p v-else-if="loading == 'failed'">laden fehlgeschlagen</p>
      <form
        v-else-if="calendarType != null"
        class="flex flex-col gap-4 py-2 w-full max-w-xl mx-auto"
        @submit.prevent="triggerUpdate"
      >
        <div>
          <label for="type">Bezeichnung</label>
          <input type="text" id="type" required v-model="calendarType.type" />
        </div>
        <div class="flex flex-row items-center gap-2">
          <input type="color" id="color" required v-model="calendarType.color" class="!px-1 !py-0 !w-10" />
          <label for="color">Farbe</label>
        </div>
        <div class="flex flex-row items-center gap-2">
          <input type="checkbox" id="nscdr" v-model="calendarType.nscdr" />
          <label for="nscdr">Standard Kalender Auslieferung (optional)</label>
        </div>
        <div v-if="!calendarType.nscdr">
          <label for="passphrase">Passphrase (optional)</label>
          <input type="text" id="passphrase" v-model="calendarType.passphrase" />
        </div>

        <div class="flex flex-row justify-end gap-2">
          <button primary-outline type="reset" class="!w-fit" :disabled="canSaveOrReset" @click="resetForm">
            verwerfen
          </button>
          <button primary type="submit" class="!w-fit" :disabled="status == 'loading' || canSaveOrReset">
            speichern
          </button>
          <Spinner v-if="status == 'loading'" class="my-auto" />
          <SuccessCheckmark v-else-if="status?.status == 'success'" />
          <FailureXMark v-else-if="status?.status == 'failed'" />
        </div>
      </form>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { useCalendarTypeStore } from "@/stores/admin/settings/calendarType";
import Spinner from "@/components/Spinner.vue";
import SuccessCheckmark from "@/components/SuccessCheckmark.vue";
import FailureXMark from "@/components/FailureXMark.vue";
import { RouterLink } from "vue-router";
import type {
  CalendarTypeViewModel,
  UpdateCalendarTypeViewModel,
} from "@/viewmodels/admin/settings/calendarType.models";
import cloneDeep from "lodash.clonedeep";
import isEqual from "lodash.isequal";
</script>

<script lang="ts">
export default defineComponent({
  props: {
    id: String,
  },
  data() {
    return {
      loading: "loading" as "loading" | "fetched" | "failed",
      status: null as null | "loading" | { status: "success" | "failed"; reason?: string },
      origin: null as null | CalendarTypeViewModel,
      calendarType: null as null | CalendarTypeViewModel,
      timeout: null as any,
    };
  },
  computed: {
    canSaveOrReset(): boolean {
      return isEqual(this.origin, this.calendarType);
    },
  },
  mounted() {
    this.fetchItem();
  },
  beforeUnmount() {
    try {
      clearTimeout(this.timeout);
    } catch (error) {}
  },
  methods: {
    ...mapActions(useCalendarTypeStore, ["fetchCalendarTypeById", "updateActiveCalendarType"]),
    resetForm() {
      this.calendarType = cloneDeep(this.origin);
    },
    fetchItem() {
      this.fetchCalendarTypeById(parseInt(this.id ?? ""))
        .then((result) => {
          this.calendarType = result.data;
          this.origin = cloneDeep(result.data);
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
    triggerUpdate(e: any) {
      if (this.calendarType == null) return;
      let formData = e.target.elements;
      let updateCalendarType: UpdateCalendarTypeViewModel = {
        id: this.calendarType.id,
        type: formData.type.value,
        color: formData.color.value,
        nscdr: formData.nscdr.checked,
        passphrase: formData.passphrase?.value,
      };
      this.status = "loading";
      this.updateActiveCalendarType(updateCalendarType)
        .then(() => {
          this.fetchItem();
          this.status = { status: "success" };
        })
        .catch((err) => {
          this.status = { status: "failed" };
        })
        .finally(() => {
          this.timeout = setTimeout(() => {
            this.status = null;
          }, 2000);
        });
    },
  },
});
</script>
